c performing the convolution of the grid file with PDFs, generating xsec coefficients
      program CONVPT
      implicit none
      integer :: pdfmember, i, j, k, ii, jj, kk, lhc, sig
      integer :: ang, scalescheme, p, Nx, Nq, nfac(42), ncall, tcall
      integer :: nt, cnt, l, n, pointor(50000), ak, ai, nstart, nend
      double precision :: XPDF(-6:6, 50, 30), xi(50), qi(30)
      double precision :: lo(38, 9), nlo(38, 9), sqrtS, beta0
      double precision :: results(42, 3), wgt(5), aux(4, 2, 3)
      double precision :: alphasPDF, as, sc, norm(30, 5)
      double precision :: chid, chiu, masscutd, masscutu, mu0, Rcone
      double precision :: scar(9)=(/0.5, 1.0, 2.0, 0.5, 1.0, 2.0, 0.5, 1.0, 2.0/)
      double precision :: scaf(9)=(/0.5, 0.5, 0.5, 1.0, 1.0, 1.0, 2.0, 2.0, 2.0/)
      double precision :: pdfpg(100, 2000, 5)
      character*100 :: pdfname, gname, oname
      character*100 :: zz, yy, xx
      external :: alphasPDF 

      call getarg(1, pdfname)
      call getarg(2, yy)
      call getarg(3, gname)
      call getarg(4, oname)
      read(yy, '(I4)') pdfmember
      pdfname=trim(adjustl(adjustr(pdfname)))
      gname="./fgrid/"//trim(adjustl(adjustr(gname)))
      oname=trim(adjustl(adjustr(oname)))

      beta0=(11*3.d0-2*5.d0)/12.d0/3.1415926d0
      cnt=0
      nt=1
      pointor=0
      nfac=0
      do i=1, 4
      nfac(i)=1
      enddo
      do i=11, 18
      nfac(i)=2
      enddo
      do i=19, 42
      nfac(i)=1
      enddo

      open(unit=155, file=gname, status="old", action="read")
      do while(0.lt.1)
      read(155, *, end=200) yy
      cnt=cnt+1
      if(yy.eq."JCC") then
      pointor(nt)=cnt
      nt=nt+1
      endif
      enddo
 200  pointor(nt)=cnt+1
      if(mod(nt-1, 3*42).ne.0) then
      print *, "wrong grid file read!"
      stop
      endif
      close(155)

      open(unit=156, file=gname, status="old", action="read")
      open(unit=157, file=oname, status="unknown")
      call InitPDFsetbyname(pdfname)
      call InitPDF(pdfmember)
      tcall=(nt-1)/(3*42)
c   begin of the main loop on the kinematic bins
      do ncall=1, tcall

      lo=0.d0
      nlo=0.d0
      wgt=0.d0
      norm=0.d0

      read(156, *) lhc, xx, sc, as
      read(156, *) sqrts, ang, scalescheme, Rcone
      read(156, *) chid, chiu, masscutd, masscutu, mu0
      read(156, *) Nx, Nq
      do i=1, Nx
      read(156, *) xi(i)
      enddo 
      do i=1, Nq
      read(156, *) qi(i) 
      enddo 

      if(lhc.eq.1) then
      sig=1
      elseif(lhc.eq.0) then
      sig=-1
      else
      print *, "wrong collider choice!"
      stop
      endif

c  calculating the alfas value at each Q grid

      do i=1, Nq
      norm(i, 1)=alphasPDF(0.25d0*qi(i)) 
      norm(i, 2)=alphasPDF(0.5d0*qi(i)) 
      norm(i, 3)=alphasPDF(1.0d0*qi(i)) 
      norm(i, 4)=alphasPDF(2.0d0*qi(i)) 
      norm(i, 5)=alphasPDF(4.0d0*qi(i)) 
      enddo 

c   calculate the PDFs in each grid points

      do ii=1, Nx
      do jj=1, Nq
      call evolvePDF(xi(ii), qi(jj), XPDF(-6, ii, jj))
      do kk=-6, 6
c   interpolation kernal is x**2*pdf
      XPDF(kk, ii, jj)=XPDF(kk, ii, jj)*xi(ii)
      enddo
      enddo
      enddo

      pdfpg=0.d0

      do i=1, Nx
      do ii=1, Nx
      do jj=1, Nq
      do k=1, 4
      do kk=k+1, 5
      pdfpg(i, jj+Nq*(ii-1), 1)=
     -   pdfpg(i, jj+Nq*(ii-1), 1)
     -   +XPDF(k, i, jj)*XPDF(sig*kk, ii, jj)
     -   +XPDF(kk, i, jj)*XPDF(sig*k, ii, jj)
     -   +XPDF(-k, i, jj)*XPDF(-sig*kk, ii, jj)
     -   +XPDF(-kk, i, jj)*XPDF(-sig*k, ii, jj)
      pdfpg(i, jj+Nq*(ii-1), 3)=
     -   pdfpg(i, jj+Nq*(ii-1), 3)
     -   +XPDF(k, i, jj)*XPDF(-sig*kk, ii, jj)
     -   +XPDF(kk, i, jj)*XPDF(-sig*k, ii, jj)
     -   +XPDF(sig*k, i, jj)*XPDF(-kk, ii, jj)
     -   +XPDF(sig*kk, i, jj)*XPDF(-k, ii, jj)
      enddo
      enddo
      do k=1, 5
      pdfpg(i, jj+Nq*(ii-1), 2)=
     -   pdfpg(i, jj+Nq*(ii-1), 2)
     -   +XPDF(k, i, jj)*XPDF(sig*k, ii, jj)
     -   +XPDF(-k, i, jj)*XPDF(-sig*k, ii, jj)
      pdfpg(i, jj+Nq*(ii-1), 4)=
     -   pdfpg(i, jj+Nq*(ii-1), 4)
     -   +XPDF(k, i, jj)*XPDF(-sig*k, ii, jj)
     -   +XPDF(sig*k, i, jj)*XPDF(-k, ii, jj)
      pdfpg(i, jj+Nq*(ii-1), 5)=
     -   pdfpg(i, jj+Nq*(ii-1), 5)
     -   +XPDF(k, i, jj)*XPDF(0, ii, jj)
     -   +XPDF(sig*k, i, jj)*XPDF(0, ii, jj)
     -   +XPDF(-k, i, jj)*XPDF(0, ii, jj)
     -   +XPDF(-sig*k, i, jj)*XPDF(0, ii, jj)
      enddo
      enddo
      enddo
      enddo

c end of PDF calculation

      aux=0.d0
c start reading the weights from the grid file for 3 scales
      do p=1, 3
      results=0.d0
      ai=5-p


      do l=1, 42
      read(156, *) yy
      nstart=pointor(l+42*(p-1)+(3*42)*(ncall-1))+1
      if((p.eq.3).and.(l.eq.42).and.(ncall.ne.tcall)) then
      nend=pointor(l+42*(p-1)+1+(3*42)*(ncall-1))-pointor(1)
      else
      nend=pointor(l+42*(p-1)+1+(3*42)*(ncall-1))-1
      endif
      do n=nstart, nend  
      read(156, *) i, j, wgt(1:5)
      ak=mod(j, Nq)
      if(ak.eq.0) ak=Nq
      do k=1, 5
      if(l.le.4) then
      aux(l, 1, p)=aux(l, 1, p)+wgt(k)*pdfpg(i, j, k)*(norm(ak, ai-1)**(nfac(l)+1))
      aux(l, 2, p)=aux(l, 2, p)+wgt(k)*pdfpg(i, j, k)*(norm(ak, ai+1)**(nfac(l)+1))
      endif
      results(l, 1)=results(l, 1)+wgt(k)*pdfpg(i, j, k)*(norm(ak, ai-1)**nfac(l))
      results(l, 2)=results(l, 2)+wgt(k)*pdfpg(i, j, k)*(norm(ak, ai)**nfac(l))
      results(l, 3)=results(l, 3)+wgt(k)*pdfpg(i, j, k)*(norm(ak, ai+1)**nfac(l))
      enddo 
      enddo
      enddo

c calculating the cross section coefficients of the CI couplings
      do k=1, 3

      do i=1, 4
      lo(1+2*(i-1), 3*(p-1)+k)=results(i, k)
      enddo
      lo(9, 3*(p-1)+k)=lo(1, 3*(p-1)+k)
      lo(11, 3*(p-1)+k)=lo(3, 3*(p-1)+k)

      do i=1, 2
      do j=1, 3
      lo(13+2*(j-1)+6*(i-1), 3*(p-1)+k)=results(4+j+3*(i-1), k)
      enddo
      enddo
      do i=1, 3
      lo(25+2*(i-1), 3*(p-1)+k)=lo(13+2*(i-1), 3*(p-1)+k)
      enddo
  
      do i=1, 4
      nlo(1+2*(i-1), 3*(p-1)+k)=results(11+2*(i-1), k)
      nlo(2+2*(i-1), 3*(p-1)+k)=results(12+2*(i-1), k)
      enddo
      do i=1, 4
      nlo(9+(i-1), 3*(p-1)+k)=nlo(1+(i-1), 3*(p-1)+k)
      enddo

      do i=1, 2
      do j=1, 5
      nlo(13+(j-1)+6*(i-1), 3*(p-1)+k)=results(19+(j-1)+6*(i-1), k)
      enddo
      nlo(18+6*(i-1), 3*(p-1)+k)=results(24+6*(i-1), k)
     -     -results(22+6*(i-1), k)-results(20+6*(i-1), k)
      enddo
      do i=1, 6
      nlo(25+(i-1), 3*(p-1)+k)=nlo(13+(i-1), 3*(p-1)+k)
      enddo

      do i=1, 2
      do j=1, 2
      nlo(31+(i-1)+2*(j-1), 3*(p-1)+k)=results(35+(i-1)+6*(j-1), k)
     -   -results(33+(i-1)+6*(j-1), k)-results(31+(i-1)+6*(j-1), k)
      enddo
      enddo
      do i=1, 4
      nlo(35+(i-1), 3*(p-1)+k)=nlo(31+(i-1), 3*(p-1)+k)
      enddo

      do i=1, 38
      nlo(i, 3*(p-1)+k)=lo(i, 3*(p-1)+k)+nlo(i, 3*(p-1)+k)
      enddo

      if(xx.ne."fital") then
      do i=1, 3
      lo(17+6*(i-1), 3*(p-1)+k)=0.d0
      lo(18+6*(i-1), 3*(p-1)+k)=0.d0
      nlo(17+6*(i-1), 3*(p-1)+k)=0.d0
      nlo(18+6*(i-1), 3*(p-1)+k)=0.d0
      enddo
      do i=31, 38
      lo(i, 3*(p-1)+k)=0.d0
      nlo(i, 3*(p-1)+k)=0.d0
      enddo
      endif

      enddo

      enddo
c end reading the weights from the grid file for 3 scales

      do i=1, 3
      do j=1, 2
      do k=1, 4
      nlo(1+2*(k-1), 1+3*(i-1)+2*(j-1))=nlo(1+2*(k-1), 1+3*(i-1)+2*(j-1))
     -  +2.d0*dlog(2.d0)*(2.d0*j-3.d0)*beta0*aux(k, j, i)
      enddo
      do k=5, 6
      nlo(1+2*(k-1), 1+3*(i-1)+2*(j-1))=nlo(1+2*(k-1), 1+3*(i-1)+2*(j-1))
     -  +2.d0*dlog(2.d0)*(2.d0*j-3.d0)*beta0*aux(k-4, j, i)
      enddo
      enddo
      enddo

c end of the calculation

c writing all the coefficients 9 scales*(LO, NLO (38 coefficients each))

      write(157, *) "LHC=", lhc, "sqrts=", sqrts, "ang=", ang, "mode=", xx, 
     -               "scalescheme=", scalescheme, "R=", Rcone
      write(157, *)  pdfname, pdfmember 
      write(157, *)  "Bin information: chid, chiu, md, mu, mu0" 
      write(157, *)  chid, chiu, masscutd, masscutu, mu0 
      write(157, *)  "9 scales(muf, mur)*(LO(38), NLO(38))" 

      do i=1, 9
  
      write (157,'(2F7.3)') scaf(i), scar(i)

      write (157,'(12D13.4)') lo(1:12, i)
      write (157,'(18D13.4)') lo(13:30, i)
      write (157,'(8D13.4)') lo(31:38, i)

      write (157,'(12D13.4)') nlo(1:12, i)
      write (157,'(18D13.4)') nlo(13:30, i)
      write (157,'(8D13.4)') nlo(31:38, i)

      enddo

c   end of the main loop on the kinematic bins
      enddo

      close(156)

      close(157)

      end program
