!====initialization subroutine for the reading========================
!====of the process parameters, kinematic parameters,=================
!====and the inputs of the calculated bins============================
      subroutine readvar
      implicit none
      character*100 file1, file2, file3

      file1='proinput.card'
      file2='kininput.card'
      file3='bininput.card'

      call proread(file1)
      call kinread(file2)
      call binread(file3)
 
      end subroutine

!=====================================================================
!=====================================================================
      subroutine proread(fil)
c reading basic process informations
      implicit none
      double precision yy
      character*100 fil, xx, zz
      integer i,j,n,ii
      include "var.inc"

      i=1
      j=0
      open(unit=127, file=fil, status='old', action='read')
      read(127,*) xx, zz
      pdfname=zz
      if(xx.ne.'pdf') then
      print *, 'wrong in proinput.card!' 
      print *, 'the first input parameter should be the pdfname!'
      stop
      endif 
      read(127,*) xx, ii
      pdfmember=ii
      if(xx.ne.'pdfmember') then
      print *, 'wrong in proinput.card!' 
      print *, 'the second input parameter should be the pdfmember!'
      stop
      endif 
      read(127,*) xx, zz
      mode=zz
      if(xx.ne.'mode') then
      print *, 'wrong in proinput.card!' 
      print *, 'the second input parameter should be the mode!'
      stop
      endif 
      Call SetLHAPARM('SILENT') 
      call InitPDFsetbyname(pdfname)
      call InitPDF(pdfmember)

      do while(i.eq.1)

      read(127,*,end=400) xx, yy
      
      if(xx.eq.'sqrtS') then
              sqrtS=yy
              j=j+1
      elseif(xx.eq.'scalescheme') then
              scalescheme=yy
              j=j+1
      elseif(xx.eq.'ppcollider') then
              ppcollider=yy
              j=j+1
      elseif(xx.eq.'many') then
              many=yy
              j=j+1
      elseif(xx.eq.'pseed') then
              pseed=yy
              j=j+1
      elseif(xx.eq.'ang') then
              ang=yy
              j=j+1
      endif

      enddo

400   close(127)

      scheme='TOT'
      gg=0.d0
      ndiagnal=1
      div=0.d0
      ncross=0
      nfac=0

      if(ppcollider.eq.1) then
              sig=1
      elseif(ppcollider.eq.0) then
              sig=-1
      else
              print *, "wrong collider!"
              stop
      endif
      
      if(j.ne.6) then
              print *, "wrong in proinput.card!"
              stop
      endif

      end subroutine

!=====================================================================
!=====================================================================
      subroutine kinread(fil)
c reading kinematic informations
      implicit none
      double precision yy
      character*100 fil, xx, zz
      integer i,j,n
      include "var.inc"

      i=1
      j=0
      open(unit=125, file=fil, status='old', action='read')


      do while(i.eq.1)

      read(125,*,end=400) xx, yy
      
      if(xx.eq.'jetscheme') then
              jetscheme=yy
              j=j+1
      elseif(xx.eq.'recscheme') then
              j=j+1
              recscheme=yy
      elseif(xx.eq.'Rcone') then
              j=j+1
              Rcone=yy
      elseif(xx.eq.'ycut') then
              j=j+1
              ycut=yy
      elseif(xx.eq.'ptcut') then
              j=j+1
              ptcut=yy
      elseif(xx.eq.'ptadd1') then
              j=j+1
              ptadd1=yy
      elseif(xx.eq.'ptadd2') then
              j=j+1
              ptadd2=yy
      elseif(xx.eq.'yb') then
              j=j+1
              yb=yy
      elseif(xx.eq.'Rsep') then
              j=j+1
              Rsep=yy
      elseif(xx.eq.'ys') then
              j=j+1
              ys=yy
      endif

      enddo

400   close(125)

      if(j.ne.10) then
              print *, "wrong in kininput.card!"
              stop
      endif

      if(jetscheme.eq.1) then
      Rcut=Rcone
      nres=0
      elseif(jetscheme.eq.2) then
      Rcut=Rsep*Rcone
      nres=1
      else
      print *, "Wrong jet scheme!"
      stop
      endif

      end subroutine

!=====================================================================
!=====================================================================
      subroutine binread(fil)
c reading information of the calculated bins
      implicit none
      integer i, j, k, n
      character*100 zz, fil
      include "var.inc"

      i=0
      j=0
      n=0
      open(unit=122, file=fil, status='old', action='read')

      do while(0.lt.1)
      read(122, *, end=300) zz
      n=n+1
      if(zz.eq.'massbin') i=n 
      if(zz.eq.'rapbin') j=n
      enddo

300   close(122)

      if((i.eq.0).or.(j.eq.0).or.(j.lt.(i+2)).or.(j.eq.n)) then
      print *, "wrong in bininput.card!"
      stop
      endif
      nbin1=1
      nbin2=j-i-1
      nbin3=n-j

      bin1(1)=5000.d0
 
      open(unit=123, file=fil, status='old', action='read')
      read(123, *) zz
      do k=1, nbin2
      read(123, *) bin2(k, 1), bin2(k, 2) 
      enddo
      read(123, *) zz
      do k=1, nbin3
      read(123, *) bin3(k, 1), bin3(k, 2) 
      enddo
      close(123)
 
      end subroutine
    
!=====================================================================
!=====================================================================
      subroutine setcoupl
c set the QCD and CI couplings
      implicit none
      double precision NC
      double precision alphasPDF, lg
      parameter (NC=3)
      external alphasPDF
      include "var.inc"

      alfas=alphasPDF(renscale)

      kappas=4.d0*pi*gs2/Nscale**2
      kappao=4.d0*pi*go2/Nscale**2

      end subroutine

      subroutine mykappa(ccc)
c  calculate running of the Wilson coefficients
      implicit none
      double precision ga(6), ke(6), alphasPDF, areomuf
      double precision ccc(6)
      integer n, i
      external alphasPDF
      include "var.inc"

      ga(1)=-0.630d0
      ga(2)=0.843d0
      ga(3)=-0.487d0
      ga(4)=0.342d0
      ga(5)=0.275d0
      ga(6)=-0.155d0

      areomuf=alphasPDF(renscale)/alphasPDF(Nscale)
      
      do i=1, 6
      ke(i)=areomuf**ga(i)
      enddo

       ccc(1)= 0. + kappao(2)*(0.03759069168527437*ke(1) + 
     -     0.03817628212952381*ke(2) - 0.04705505435139814*ke(5) - 
     -     0.02871191946340002*ke(6)) + 
     -  kappao(1)*(0.07714782105885992*ke(1) - 
     -     0.0178600454307246*ke(2) + 0.10495671428119793*ke(3) - 
     -     0.10495671428119795*ke(4) - 0.07550667504684229*ke(5) + 
     -     0.016218899418706946*ke(6)) + 
     -  kappao(3)*(0.07714782105885992*ke(1) - 
     -     0.017860045430724607*ke(2) - 0.10495671428119793*ke(3) + 
     -     0.10495671428119795*ke(4) - 0.07550667504684229*ke(5) + 
     -     0.016218899418706953*ke(6)) + 
     -  kappas(3)*(0.12749613710120902*ke(1) + 
     -     0.012387808933542275*ke(2) - 0.20626803571616753*ke(3) - 
     -     0.2937319642838325*ke(4) + 0.2921928608829245*ke(5) + 
     -     0.06792319308232424*ke(6)) + 
     -  kappas(1)*(0.12749613710120902*ke(1) + 
     -     0.012387808933542275*ke(2) + 0.20626803571616753*ke(3) + 
     -     0.2937319642838325*ke(4) + 0.2921928608829245*ke(5) + 
     -     0.06792319308232424*ke(6)) + 
     -  kappas(2)*(-0.04669156268536159*ke(1) + 
     -     0.03543716226867298*ke(2) - 0.1338213063932936*ke(5) + 
     -     0.1450757068099822*ke(6))

       ccc(2)= 0. + kappao(2)*(0.1361867131980069*ke(1) - 
     -     0.1850720517016752*ke(2) + 0.07445601824253285*ke(5) - 
     -     0.025570679738864566*ke(6)) + 
     -  kappao(1)*(0.2794976019158991*ke(1) + 
     -     0.08658242937682735*ke(2) + 0.29373196428383247*ke(3) + 
     -     0.20626803571616753*ke(4) + 0.11947550485729375*ke(5) + 
     -     0.014444463849979765*ke(6)) + 
     -  kappao(3)*(0.2794976019158991*ke(1) + 
     -     0.08658242937682739*ke(2) - 0.29373196428383247*ke(3) - 
     -     0.20626803571616753*ke(4) + 0.11947550485729375*ke(5) + 
     -     0.014444463849979773*ke(6)) + 
     -  kappas(1)*(0.46190370750900406*ke(1) - 
     -     0.06005396773946167*ke(2) + 0.5772619285465886*ke(3) - 
     -     0.5772619285465886*ke(4) - 0.4623417671090305*ke(5) + 
     -     0.0604920273394881*ke(6)) + 
     -  kappas(3)*(0.46190370750900406*ke(1) - 
     -     0.06005396773946167*ke(2) - 0.5772619285465886*ke(3) + 
     -     0.5772619285465886*ke(4) - 0.4623417671090305*ke(5) + 
     -     0.0604920273394881*ke(6)) + 
     -  kappas(2)*(-0.16915811258373467*ke(1) - 
     -     0.1717932695828573*ke(2) + 0.21174774458129156*ke(5) + 
     -     0.12920363758530037*ke(6))

       ccc(3)= 0. + kappao(2)*(-0.038234937031424734*ke(1) + 
     -     0.13885882634054225*ke(2) + 0.03991264875626206*ke(5) - 
     -     0.14053653806537952*ke(6)) + 
     -  kappao(1)*(-0.07847001340102111*ke(1) - 
     -     0.0649624533495692*ke(2) + 0.06404564698602434*ke(5) + 
     -     0.07938681976456595*ke(6)) + 
     -  kappao(3)*(-0.07847001340102111*ke(1) - 
     -     0.06496245334956922*ke(2) + 0.06404564698602434*ke(5) + 
     -     0.07938681976456599*ke(6)) + 
     -  kappas(1)*(-0.12968122041032462*ke(1) + 
     -     0.04505825380288338*ke(2) - 0.2478414101579078*ke(5) + 
     -     0.3324643767653491*ke(6)) + 
     -  kappas(3)*(-0.12968122041032462*ke(1) + 
     -     0.04505825380288338*ke(2) - 0.2478414101579078*ke(5) + 
     -     0.3324643767653491*ke(6)) + 
     -  kappas(2)*(0.047491782649824656*ke(1) + 
     -     0.1288958087844228*ke(2) + 0.11350880095245183*ke(5) + 
     -     0.7101036076133008*ke(6))

       ccc(4)= 0. + kappas(2)*(-0.17205721664141085*ke(1) + 
     -     0.6248647185324409*ke(2) + 0.17960691940317927*ke(5) - 
     -     0.6324144212942092*ke(6)) + 
     -  kappas(1)*(0.46982001073703966*ke(1) + 
     -     0.218434667082089*ke(2) - 0.39216370717939586*ke(5) - 
     -     0.2960909706397328*ke(6)) + 
     -  kappas(3)*(0.46982001073703966*ke(1) + 
     -     0.218434667082089*ke(2) - 0.39216370717939586*ke(5) - 
     -     0.2960909706397328*ke(6)) + 
     -  kappao(3)*(0.28428775131783246*ke(1) - 
     -     0.3149268041395079*ke(2) + 0.10134052390494286*ke(5) - 
     -     0.07070147108326746*ke(6)) + 
     -  kappao(1)*(0.28428775131783246*ke(1) - 
     -     0.3149268041395078*ke(2) + 0.10134052390494286*ke(5) - 
     -     0.07070147108326742*ke(6)) + 
     -  kappao(2)*(0.13852073931595904*ke(1) + 
     -     0.673163714594838*ke(2) + 0.06315446756711177*ke(5) + 
     -     0.1251610785220912*ke(6))

       ccc(5)= 0. + kappao(2)*(0.03759069168527437*ke(1) + 
     -     0.03817628212952381*ke(2) - 0.04705505435139814*ke(5) - 
     -     0.02871191946340002*ke(6)) + 
     -  kappao(1)*(0.07714782105885992*ke(1) - 
     -     0.0178600454307246*ke(2) - 0.10495671428119793*ke(3) + 
     -     0.10495671428119795*ke(4) - 0.07550667504684229*ke(5) + 
     -     0.016218899418706946*ke(6)) + 
     -  kappao(3)*(0.07714782105885992*ke(1) - 
     -     0.017860045430724607*ke(2) + 0.10495671428119793*ke(3) - 
     -     0.10495671428119795*ke(4) - 0.07550667504684229*ke(5) + 
     -     0.016218899418706953*ke(6)) + 
     -  kappas(1)*(0.12749613710120902*ke(1) + 
     -     0.012387808933542275*ke(2) - 0.20626803571616753*ke(3) - 
     -     0.2937319642838325*ke(4) + 0.2921928608829245*ke(5) + 
     -     0.06792319308232424*ke(6)) + 
     -  kappas(3)*(0.12749613710120902*ke(1) + 
     -     0.012387808933542275*ke(2) + 0.20626803571616753*ke(3) + 
     -     0.2937319642838325*ke(4) + 0.2921928608829245*ke(5) + 
     -     0.06792319308232424*ke(6)) + 
     -  kappas(2)*(-0.04669156268536159*ke(1) + 
     -     0.03543716226867298*ke(2) - 0.1338213063932936*ke(5) + 
     -     0.1450757068099822*ke(6))

       ccc(6)= 0. + kappao(2)*(0.1361867131980069*ke(1) - 
     -     0.1850720517016752*ke(2) + 0.07445601824253285*ke(5) - 
     -     0.025570679738864566*ke(6)) + 
     -  kappao(1)*(0.2794976019158991*ke(1) + 
     -     0.08658242937682735*ke(2) - 0.29373196428383247*ke(3) - 
     -     0.20626803571616753*ke(4) + 0.11947550485729375*ke(5) + 
     -     0.014444463849979765*ke(6)) + 
     -  kappao(3)*(0.2794976019158991*ke(1) + 
     -     0.08658242937682739*ke(2) + 0.29373196428383247*ke(3) + 
     -     0.20626803571616753*ke(4) + 0.11947550485729375*ke(5) + 
     -     0.014444463849979773*ke(6)) + 
     -  kappas(3)*(0.46190370750900406*ke(1) - 
     -     0.06005396773946167*ke(2) + 0.5772619285465886*ke(3) - 
     -     0.5772619285465886*ke(4) - 0.4623417671090305*ke(5) + 
     -     0.0604920273394881*ke(6)) + 
     -  kappas(1)*(0.46190370750900406*ke(1) - 
     -     0.06005396773946167*ke(2) - 0.5772619285465886*ke(3) + 
     -     0.5772619285465886*ke(4) - 0.4623417671090305*ke(5) + 
     -     0.0604920273394881*ke(6)) + 
     -  kappas(2)*(-0.16915811258373467*ke(1) - 
     -     0.1717932695828573*ke(2) + 0.21174774458129156*ke(5) + 
     -     0.12920363758530037*ke(6))

      end subroutine

