      subroutine ggoxxx(vc1,vc2,vc3)
c
c This subroutine computes an amplitude of the three-point coupling of
c the gluon.
c
c input:
c       complex vc1(6)          : vector               flow-out g
c       complex vc2(6)          : vector               flow-out g
c
c output:
c       complex vc3(6)          : vector               flow-out g
c
      implicit none
      double complex vc1(6),vc2(6),vc3(6),d,s1,s2,s3
      double precision pf1(0:3),pf2(0:3),pf3(0:3),p2

      double complex cImag
      parameter ( cImag = ( 0.0d0, 1.0d0 ))
      double precision rZero, rTenth
      parameter( rZero = 0.0d0, rTenth = 0.1d0 )

      pf1(0) = dble( vc1(5))
      pf1(1) = dble( vc1(6))
      pf1(2) = dimag(vc1(6))
      pf1(3) = dimag(vc1(5))
      pf2(0) = dble( vc2(5))
      pf2(1) = dble( vc2(6))
      pf2(2) = dimag(vc2(6))
      pf2(3) = dimag(vc2(5))
      pf3(0) = -pf1(0)-pf2(0)
      pf3(1) = -pf1(1)-pf2(1)
      pf3(2) = -pf1(2)-pf2(2)
      pf3(3) = -pf1(3)-pf2(3)
      p2=pf3(0)**2-pf3(1)**2-pf3(2)**2-pf3(3)**2


      d=1.d0/cmplx(p2, 0.d0)
      s1=vc1(1)*vc2(1)-vc1(2)*vc2(2)-vc1(3)*vc2(3)-vc1(4)*vc2(4)
      s2=vc1(1)*(pf2(0)-pf3(0))-vc1(2)*(pf2(1)-pf3(1))
     &   -vc1(3)*(pf2(2)-pf3(2))-vc1(4)*(pf2(3)-pf3(3))
      s3=vc2(1)*(pf3(0)-pf1(0))-vc2(2)*(pf3(1)-pf1(1))
     &   -vc2(3)*(pf3(2)-pf1(2))-vc2(4)*(pf3(3)-pf1(3))

      vc3(5)=vc1(5)+vc2(5)
      vc3(6)=vc1(6)+vc2(6)
      vc3(1)=d*(s1*(pf1(0)-pf2(0))+s2*vc2(1)+s3*vc1(1))
      vc3(2)=d*(s1*(pf1(1)-pf2(1))+s2*vc2(2)+s3*vc1(2))
      vc3(3)=d*(s1*(pf1(2)-pf2(2))+s2*vc2(3)+s3*vc1(3))
      vc3(4)=d*(s1*(pf1(3)-pf2(3))+s2*vc2(4)+s3*vc1(4))
c
      return
      end
