      subroutine iovxxx(fi,fo,vc, vertex)
c
c This subroutine computes an amplitude of the fermion-fermion-vector
c coupling.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex vc(6)          : input    vector                      v
c
c output:
c       complex vertex         : amplitude                     <fo|v|fi>
c     
      implicit none
      double complex fi(6),fo(6),vc(6),vertex

      double precision rZero, rOne
      parameter( rZero = 0.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )


        vertex= cImag*(fi(2)*
     -     (fo(3)*(vc(2) - cImag*vc(3)) + 
     -       fo(4)*(vc(1) - vc(4))) - 
     -    fi(3)*(fo(2)*
     -        (vc(2) + cImag*vc(3)) + 
     -       fo(1)*(-vc(1) + vc(4))) + 
     -    fi(4)*(fo(1)*
     -        (-vc(2) + cImag*vc(3)) + 
     -       fo(2)*(vc(1) + vc(4))) + 
     -    fi(1)*(fo(4)*
     -        (vc(2) + cImag*vc(3)) + 
     -       fo(3)*(vc(1) + vc(4))))

c
      end
