!=============calculation of the 2->2 amplitudes at both LO and NLO for CIs and QCD======
!========================================================================================
      subroutine Amptree(s, u)
c returning the 2->2 tree level amplitudes for the CIs and QCD
      implicit none
      integer i, j, k
      double precision s, u, t
      include "calc.h"

      do i=1, 4   !color
      do j=1, 6   !ME basis
      do k=0, 6   !couplings
      qqCtree(i, j, k)=0.d0
      qqxCtree(i, j, k)=0.d0
      enddo
      enddo
      enddo

      t=-s-u

      qqCtree(1, 1, 1)=1.d0
      qqCtree(1, 2, 3)=1.d0/2.d0  
      qqCtree(1, 3, 5)=1.d0  
      qqCtree(2, 1, 2)=1.d0  
      qqCtree(2, 2, 4)=1.d0/2.d0 
      qqCtree(2, 3, 6)=1.d0  
      qqCtree(2, 1, 0)=1.d0/t  
      qqCtree(2, 2, 0)=1.d0/t  
      qqCtree(2, 3, 0)=1.d0/t  

      qqCtree(3, 4, 1)=-1.d0
      qqCtree(3, 5, 3)=-1.d0/2.d0  
      qqCtree(3, 6, 5)=-1.d0  
      qqCtree(4, 4, 2)=-1.d0  
      qqCtree(4, 5, 4)=-1.d0/2.d0 
      qqCtree(4, 6, 6)=-1.d0  
      qqCtree(4, 4, 0)=-1.d0/u  
      qqCtree(4, 5, 0)=-1.d0/u  
      qqCtree(4, 6, 0)=-1.d0/u  

      qqxCtree(1, 1, 1)=1.d0
      qqxCtree(1, 2, 3)=1.d0/2.d0
      qqxCtree(1, 3, 5)=1.d0
      qqxCtree(2, 1, 2)=1.d0  
      qqxCtree(2, 2, 4)=1.d0/2.d0  
      qqxCtree(2, 3, 6)=1.d0  
      qqxCtree(2, 1, 0)=1.d0/t  
      qqxCtree(2, 2, 0)=1.d0/t  
      qqxCtree(2, 3, 0)=1.d0/t  

      qqxCtree(3, 4, 1)=-1.d0
      qqxCtree(3, 5, 3)=-1.d0/2.d0
      qqxCtree(3, 6, 5)=-1.d0
      qqxCtree(4, 4, 2)=-1.d0  
      qqxCtree(4, 5, 4)=-1.d0/2.d0  
      qqxCtree(4, 6, 6)=-1.d0  
      qqxCtree(4, 4, 0)=-1.d0/s  
      qqxCtree(4, 5, 0)=-1.d0/s  
      qqxCtree(4, 6, 0)=-1.d0/s  

      end subroutine


      subroutine Ampvirtual(s, u)
c returning the 2->2 loop level amplitudes for the CIs and QCD
      implicit none
      integer i, j, k  
      double precision s, u, t, lgsol
      double precision lgsot, lgsou, lgsomr
      double precision lglot, lglou, lglos, addq
      double precision sss, ssu, sst
      double precision qqsot, qqtos, qqsou, qquos, qquot, qqtou
      external addq
      include "calc.h"

      do i=1, 4   !color
      do j=1, 6   !ME basis
      do k=0, 6   !couplings
      qqCloop(i, j, k)=0.d0
      qqxCloop(i, j, k)=0.d0
      enddo
      enddo
      enddo

      t=-s-u

      lgsot=dlog(-s/t)
      lgsou=dlog(-s/u)
      lgsomr=dlog(s/renscale**2)
      lgsol=dlog(s/mu0**2)-2.d0*gg
      lglot=dlog(-mu0**2/t)+2.d0*gg
      lglou=dlog(-mu0**2/u)+2.d0*gg
      lglos=dlog(mu0**2/s)+2.d0*gg
      sss=3.d0*(2.d0+lglos)
      sst=3.d0*(2.d0+lglot)
      ssu=3.d0*(2.d0+lglou)
      qqsot=addq(s/t)
      qqtos=addq(t/s)
      qqsou=addq(s/u)
      qquos=addq(u/s)
      qquot=addq(u/t)
      qqtou=addq(t/u)


      if(ndiagnal.eq.1) then ! calculate the diagnal parts  

       qqCloop(1, 1, 0)= (alfas*((-2*lgsot*s + lgsot**2*(s - u) + 
     -         Pi**2*(s - u))*(s + u) + 
     -      lgsou**2*(s**2 - u**2) + 
     -      2*lgsou*((1 + 2*div + lgsot)*s**2 + s*u + 
     -         lgsot*u**2)))/(18.*Pi*s**2*(s + u))


       qqCloop(3, 4, 0)= -(alfas*((-2*lgsou*s + lgsou**2*(s - t) + 
     -          Pi**2*(s - t))*(s + t) + 
     -       lgsot**2*(s**2 - t**2) + 
     -       2*lgsot*((1 + 2*div + lgsou)*s**2 + s*t + 
     -          lgsou*t**2)))/(18.*Pi*s**2*(s + t))

  
       qqCloop(1, 1, 1)=  (-2*alfas*(8 + 2*div**2 + 3*lgsot + lgsot**2 + 
     -      div*(3 + 2*lgsot)))/(3.*Pi)

 
       qqCloop(3, 4, 1)=  (2*alfas*(8 + 2*div**2 + 3*lgsou + lgsou**2 + 
     -      div*(3 + 2*lgsou)))/(3.*Pi)

 
       qqCloop(1, 1, 2)=  -(alfas*(9 - 3*lgsol + (3 + 2*div)*lgsou + 
     -       lgsou**2 + Pi**2))/(9.*Pi)

 
       qqCloop(3, 4, 2)=   (alfas*(9 - 3*lgsol + (3 + 2*div)*lgsot + lgsot**2 + 
     -      Pi**2))/(9.*Pi)

 
       qqCloop(2, 1, 0)=   (alfas*((-126 + 96*div**2 + 198*lgsomr - 96*lgsot - 
     -         39*lgsot**2 - 12*div*(-12 + lgsot - 7*lgsou) + 
     -         42*lgsou + 42*lgsot*lgsou + 21*lgsou**2 + 
     -         20*nf - 12*lgsomr*nf + 12*lgsot*nf - 33*Pi**2)*
     -       s**2 - 42*(lgsot - lgsou)*s*u - 
     -      21*(lgsot**2 - 2*lgsot*lgsou + lgsou**2 + Pi**2)*
     -       u**2))/(72.*Pi*s**2*(s + u))


       qqCloop(4, 4, 0)=   (alfas*(-((-126 + 96*div**2 + 198*lgsomr + 42*lgsot + 
     -           21*lgsot**2 + 
     -           12*div*(12 + 7*lgsot - lgsou) - 96*lgsou + 
     -           42*lgsot*lgsou - 39*lgsou**2 + 20*nf - 
     -           12*lgsomr*nf + 12*lgsou*nf - 33*Pi**2)*s**2)
     -       - 42*(lgsot - lgsou)*s*t + 
     -      21*(lgsot**2 - 2*lgsot*lgsou + lgsou**2 + Pi**2)*
     -       t**2))/(72.*Pi*s**2*(s + t))

  
       qqCloop(2, 1, 1)=  -(alfas*(9 - 3*lgsol + (3 + 2*div)*lgsou + 
     -       lgsou**2 + Pi**2))/(2.*Pi)

 
       qqCloop(4, 4, 1)=   (alfas*(9 - 3*lgsol + (3 + 2*div)*lgsot + lgsot**2 + 
     -      Pi**2))/(2.*Pi)

 
       qqCloop(2, 1, 2)=   (alfas*(-46 - 16*div**2 - 6*lgsol + 3*lgsot + 
     -      lgsot**2 + 2*div*(-12 + lgsot - 7*lgsou) - 
     -      21*lgsou - 7*lgsou**2 + 2*Pi**2))/(12.*Pi)

 
       qqCloop(4, 4, 2)=   (alfas*(46 + 16*div**2 + 6*lgsol + 21*lgsot + 
     -      7*lgsot**2 + 2*div*(12 + 7*lgsot - lgsou) - 
     -      3*lgsou - lgsou**2 - 2*Pi**2))/(12.*Pi)


       qqxCloop(1, 1, 0)=  -(alfas*(4*(div + lgsot)*lgsou*u**2 + 
     -       lgsot*(s + u)*(lgsot*(s - u) + 2*u)))/
     -  (18.*Pi*u**2*(s + u))


       qqxCloop(3, 4, 0)=  -(alfas*(4*div*lgsou*u**2 + lgsot**2*s*(s + 2*u) + 
     -       2*lgsot*u*(s - 2*div*u)))/(18.*Pi*s*u**2)


       qqxCloop(1, 1, 1)=  (-2*alfas*(8 + div*(3 + 2*div) + 
     -      lgsot*(3 + 2*div + lgsot)))/(3.*Pi)


       qqxCloop(3, 4, 1)= (2*alfas*(8 + div*(3 + 2*div) - Pi**2))/(3.*Pi)


       qqxCloop(1, 1, 2)= (alfas*(-9 + 3*lgsol + 2*div*lgsou + lgsou**2 + 
     -      Pi**2))/(9.*Pi)


       qqxCloop(3, 4, 2)= (alfas*(9 - 3*lgsol + lgsot*(3 + 2*div + lgsot) - 
     -      2*div*lgsou - lgsou**2))/(9.*Pi)


       qqxCloop(2, 1, 0)=  -(alfas*(-2*(-63 + 48*div**2 + 99*lgsomr + 
     -          12*div*(6 + lgsou) + 10*nf - 6*lgsomr*nf - 
     -          27*Pi**2)*u**2 + 
     -       6*lgsot*u*(7*s + 
     -          2*(8 + div - 2*lgsou - nf)*u) + 
     -       3*lgsot**2*(7*s**2 + 13*u**2)))/
     -  (72.*Pi*u**2*(s + u))


       qqxCloop(4, 4, 0)=  (alfas*(2*(-63 + 48*div**2 + 99*lgsomr + 
     -         12*div*(6 + lgsou) + 10*nf - 6*lgsomr*nf + 
     -         3*Pi**2)*u**2 - 21*lgsot**2*s*(s + 2*u) - 
     -      42*lgsot*u*(s - 2*div*u)))/(72.*Pi*s*u**2)


       qqxCloop(2, 1, 1)=  (alfas*(-9 + 3*lgsol + 2*div*lgsou + lgsou**2 + 
     -      Pi**2))/(2.*Pi)


       qqxCloop(4, 4, 1)=  (alfas*(9 - 3*lgsol + lgsot*(3 + 2*div + lgsot) - 
     -      2*div*lgsou - lgsou**2))/(2.*Pi)


       qqxCloop(2, 1, 2)=  (alfas*(-46 - 8*div*(3 + 2*div) - 6*lgsol + 
     -      lgsot*(3 + 2*div + lgsot) - 4*div*lgsou - 
     -      2*lgsou**2 + 7*Pi**2))/(12.*Pi)


       qqxCloop(4, 4, 2)=  (alfas*(46 + 8*div*(3 + 2*div) + 6*lgsol + 
     -      7*lgsot*(3 + 2*div + lgsot) + 4*div*lgsou + 
     -      2*lgsou**2 + Pi**2))/(12.*Pi)


      do i=1, 4   !color
      do k=3, 4   !couplings
      qqCloop(i, 2, k)=qqCloop(i, 1, k-2)/2.d0
      qqxCloop(i, 2, k)=qqxCloop(i, 1, k-2)/2.d0
      qqCloop(i, 5, k)=qqCloop(i, 4, k-2)/2.d0
      qqxCloop(i, 5, k)=qqxCloop(i, 4, k-2)/2.d0
      enddo
      enddo

      qqCloop(2, 2, 3)=qqCloop(2, 2, 3)+(alfas*(sss+ssu))/4.d0/Pi
      qqCloop(4, 5, 3)=qqCloop(4, 5, 3)-(alfas*(sss+sst))/4.d0/Pi
      qqCloop(1, 2, 4)=qqCloop(1, 2, 4)+(alfas*2.d0/9.d0*(sss+ssu))/4.d0/Pi
      qqCloop(3, 5, 4)=qqCloop(3, 5, 4)-(alfas*2.d0/9.d0*(sss+sst))/4.d0/Pi
      qqCloop(2, 2, 4)=qqCloop(2, 2, 4)+(alfas*(-sss/3.d0+7.d0*ssu/6.d0))/4.d0/Pi
      qqCloop(4, 5, 4)=qqCloop(4, 5, 4)-(alfas*(-sss/3.d0+7.d0*sst/6.d0))/4.d0/Pi

      qqxCloop(2, 2, 3)=qqxCloop(2, 2, 3)+(alfas*(sss+ssu))/4.d0/Pi
      qqxCloop(4, 5, 3)=qqxCloop(4, 5, 3)-(alfas*(sst+ssu))/4.d0/Pi
      qqxCloop(1, 2, 4)=qqxCloop(1, 2, 4)+(alfas*2.d0/9.d0*(sss+ssu))/4.d0/Pi
      qqxCloop(3, 5, 4)=qqxCloop(3, 5, 4)-(alfas*2.d0/9.d0*(sst+ssu))/4.d0/Pi
      qqxCloop(2, 2, 4)=qqxCloop(2, 2, 4)+(alfas*(-ssu/3.d0+7.d0*sss/6.d0))/4.d0/Pi
      qqxCloop(4, 5, 4)=qqxCloop(4, 5, 4)-(alfas*(-ssu/3.d0+7.d0*sst/6.d0))/4.d0/Pi

      do i=1, 4   !color
      do k=0, 0   !couplings
      qqCloop(i, 3, k)=qqCloop(i, 1, k)
      qqxCloop(i, 3, k)=qqxCloop(i, 1, k)
      qqCloop(i, 6, k)=qqCloop(i, 4, k)
      qqxCloop(i, 6, k)=qqxCloop(i, 4, k)
      qqCloop(i, 2, k)=qqCloop(i, 1, k)
      qqxCloop(i, 2, k)=qqxCloop(i, 1, k)
      qqCloop(i, 5, k)=qqCloop(i, 4, k)
      qqxCloop(i, 5, k)=qqxCloop(i, 4, k)
      enddo
      enddo

      qqCloop(1, 2, 0)=qqCloop(1, 2, 0)+(alfas*2.d0/9.d0*(qqsot+qquot))/4.d0/Pi/t
      qqCloop(3, 5, 0)=qqCloop(3, 5, 0)-(alfas*2.d0/9.d0*(qqsou+qqtou))/4.d0/Pi/u
      qqCloop(2, 2, 0)=qqCloop(2, 2, 0)+(alfas*(-qqsot/3.d0+7.d0*qquot/6.d0))/4.d0/Pi/t
      qqCloop(4, 5, 0)=qqCloop(4, 5, 0)-(alfas*(-qqsou/3.d0+7.d0*qqtou/6.d0))/4.d0/Pi/u

      qqxCloop(1, 2, 0)=qqxCloop(1, 2, 0)+(alfas*2.d0/9.d0*(qquot+qqsot))/4.d0/Pi/t
      qqxCloop(3, 5, 0)=qqxCloop(3, 5, 0)-(alfas*2.d0/9.d0*(qquos+qqtos))/4.d0/Pi/s
      qqxCloop(2, 2, 0)=qqxCloop(2, 2, 0)+(alfas*(-qquot/3.d0+7.d0*qqsot/6.d0))/4.d0/Pi/t
      qqxCloop(4, 5, 0)=qqxCloop(4, 5, 0)-(alfas*(-qquos/3.d0+7.d0*qqtos/6.d0))/4.d0/Pi/s

      endif  

! panguin diagrames

        qqCloop(2,1,1)=qqCloop(2,1,1)+2.d0*alfas/4.d0/pi* !new loop 1
     -       (-2.d0/3.d0*(lglot+2.d0/3.d0))

        qqCloop(4,4,1)=qqCloop(4,4,1)-2.d0*alfas/4.d0/pi* ! new loop 1
     -       (-2.d0/3.d0*(lglou+2.d0/3.d0))

        qqCloop(2,1,2)=qqCloop(2,1,2)+2.d0*alfas/4.d0/pi*  ! new loop 1
     -     (2.d0/3.d0*(lglot+2.d0/3.d0)/6.d0
     -    -2.d0*nf/3.d0*(lglot+5.d0/3.d0)/2.d0)

        qqCloop(4,4,2)=qqCloop(4,4,2)-2.d0*alfas/4.d0/pi*  ! new loop 1
     -     (2.d0/3.d0*(lglou+2.d0/3.d0)/6.d0
     -    -2.d0*nf/3.d0*(lglou+5.d0/3.d0)/2.d0)

        qqCloop(2,2,1)=alfas/4.d0/pi* !new loop 1
     -       (-2.d0/3.d0*(lglot+2.d0/3.d0))

        qqCloop(4,5,1)=-alfas/4.d0/pi* ! new loop 1
     -       (-2.d0/3.d0*(lglou+2.d0/3.d0))

        qqCloop(2,2,2)=alfas/4.d0/pi*  ! new loop 1
     -     (2.d0/3.d0*(lglot+2.d0/3.d0)/6.d0
     -    -2.d0*nf/3.d0*(lglot+5.d0/3.d0)/2.d0)

        qqCloop(4,5,2)=-alfas/4.d0/pi*  ! new loop 1
     -     (2.d0/3.d0*(lglou+2.d0/3.d0)/6.d0
     -    -2.d0*nf/3.d0*(lglou+5.d0/3.d0)/2.d0)

        qqxCloop(2,1,1)=qqxCloop(2,1,1)+2.d0*alfas/4.d0/pi*   ! new loop 1
     -       (-2.d0/3.d0*(lglot+2.d0/3.d0))

        qqxCloop(4,4,1)=qqxCloop(4,4,1)-2.d0*alfas/4.d0/pi*  ! new loop 1
     -       (-2.d0/3.d0*(lglos+2.d0/3.d0))

        qqxCloop(2,1,2)=qqxCloop(2,1,2)+2.d0*alfas/4.d0/pi*  ! new loop 1
     -     (2.d0/3.d0*(lglot+2.d0/3.d0)/6.d0
     -    -2.d0*nf/3.d0*(lglot+5.d0/3.d0)/2.d0)

        qqxCloop(4,4,2)=qqxCloop(4,4,2)-2.d0*alfas/4.d0/pi*   ! new loop 1
     -     (2.d0/3.d0*(lglos+2.d0/3.d0)/6.d0
     -    -2.d0*nf/3.d0*(lglos+5.d0/3.d0)/2.d0)

        qqxCloop(2,2,1)=alfas/4.d0/pi*   ! new loop 1
     -       (-2.d0/3.d0*(lglot+2.d0/3.d0))

        qqxCloop(4,5,1)=-alfas/4.d0/pi*  ! new loop 1
     -       (-2.d0/3.d0*(lglos+2.d0/3.d0))

        qqxCloop(2,2,2)=alfas/4.d0/pi*  ! new loop 1
     -     (2.d0/3.d0*(lglot+2.d0/3.d0)/6.d0
     -    -2.d0*nf/3.d0*(lglot+5.d0/3.d0)/2.d0)

        qqxCloop(4,5,2)=-alfas/4.d0/pi*   ! new loop 1
     -     (2.d0/3.d0*(lglos+2.d0/3.d0)/6.d0
     -    -2.d0*nf/3.d0*(lglos+5.d0/3.d0)/2.d0)

        qqCloop(2,1,4)=+alfas/4.d0/pi* !new loop 3
     -       (-2.d0*nf/3.d0*(lglot+5.d0/3.d0)/2.d0)

        qqCloop(4,4,4)=-alfas/4.d0/pi* !new loop 3
     -       (-2.d0*nf/3.d0*(lglou+5.d0/3.d0)/2.d0)

        qqCloop(2,3,4)=+alfas/4.d0/pi* !new loop 3
     -       (-2.d0*nf/3.d0*(lglot+5.d0/3.d0)/2.d0)

        qqCloop(4,6,4)=-alfas/4.d0/pi* !new loop 3
     -       (-2.d0*nf/3.d0*(lglou+5.d0/3.d0)/2.d0)

        qqCloop(2,2,4)=qqCloop(2,2,4)+alfas/4.d0/pi* !new loop 3
     -       (-2.d0*nf/3.d0*(lglot+5.d0/3.d0)/2.d0)

        qqCloop(4,5,4)=qqCloop(4,5,4)-alfas/4.d0/pi* !new loop 3
     -       (-2.d0*nf/3.d0*(lglou+5.d0/3.d0)/2.d0)

        qqxCloop(2,1,4)=+alfas/4.d0/pi* !new loop 3
     -       (-2.d0*nf/3.d0*(lglot+5.d0/3.d0)/2.d0)

        qqxCloop(4,4,4)=-alfas/4.d0/pi* !new loop 3
     -       (-2.d0*nf/3.d0*(lglos+5.d0/3.d0)/2.d0)

        qqxCloop(2,3,4)=+alfas/4.d0/pi* !new loop 3
     -       (-2.d0*nf/3.d0*(lglot+5.d0/3.d0)/2.d0)

        qqxCloop(4,6,4)=-alfas/4.d0/pi* !new loop 3
     -       (-2.d0*nf/3.d0*(lglos+5.d0/3.d0)/2.d0)

        qqxCloop(2,2,4)=qqxCloop(2,2,4)+alfas/4.d0/pi* !new loop 3
     -       (-2.d0*nf/3.d0*(lglot+5.d0/3.d0)/2.d0)

        qqxCloop(4,5,4)=qqxCloop(4,5,4)-alfas/4.d0/pi* !new loop 3
     -       (-2.d0*nf/3.d0*(lglos+5.d0/3.d0)/2.d0)

      do i=1, 4   !color
      do k=5, 6   !couplings
      qqCloop(i, 3, k)=qqCloop(i, 1, k-4)
      qqxCloop(i, 3, k)=qqxCloop(i, 1, k-4)
      qqCloop(i, 6, k)=qqCloop(i, 4, k-4)
      qqxCloop(i, 6, k)=qqxCloop(i, 4, k-4)
      qqCloop(i, 2, k)=qqCloop(i, 2, k-4)
      qqxCloop(i, 5, k)=qqxCloop(i, 5, k-4)
      qqCloop(i, 2, k)=qqCloop(i, 2, k-4)
      qqxCloop(i, 5, k)=qqxCloop(i, 5, k-4)
      enddo
      enddo

      end subroutine 

      double precision function addq(x)
c Auxiliary function 
      implicit none
      double precision x, pi
      parameter (pi = 3.1415926535897932384626433832795029D0)

      if(x.lt.0.d0) then
      addq=-2.d0*dlog(-x)/(1.d0+x)+(1.d0+2.d0*x)/(1.d0+x)**2*(dlog(-x))**2 
      else
      addq=-2.d0*dlog(x)/(1.d0+x)+(1.d0+2.d0*x)/(1.d0+x)**2*((dlog(x))**2-Pi**2) 
      endif

      end function


      DOUBLE PRECISION FUNCTION DDILOG(X)
c Li2 function from MCFM

      DOUBLE PRECISION X,Y,T,S,A,PI3,PI6,ZERO,ONE,HALF,MALF,MONE,MTWO
      DOUBLE PRECISION C(0:18),H,ALFA,B0,B1,B2

      DATA ZERO /0.0D0/, ONE /1.0D0/
      DATA HALF /0.5D0/, MALF /-0.5D0/, MONE /-1.0D0/, MTWO /-2.0D0/
      DATA PI3 /3.28986 81336 96453D0/, PI6 /1.64493 40668 48226D0/

      DATA C( 0) / 0.42996 69356 08137 0D0/
      DATA C( 1) / 0.40975 98753 30771 1D0/
      DATA C( 2) /-0.01858 84366 50146 0D0/
      DATA C( 3) / 0.00145 75108 40622 7D0/
      DATA C( 4) /-0.00014 30418 44423 4D0/
      DATA C( 5) / 0.00001 58841 55418 8D0/
      DATA C( 6) /-0.00000 19078 49593 9D0/
      DATA C( 7) / 0.00000 02419 51808 5D0/
      DATA C( 8) /-0.00000 00319 33412 7D0/
      DATA C( 9) / 0.00000 00043 45450 6D0/
      DATA C(10) /-0.00000 00006 05784 8D0/
      DATA C(11) / 0.00000 00000 86121 0D0/
      DATA C(12) /-0.00000 00000 12443 3D0/
      DATA C(13) / 0.00000 00000 01822 6D0/
      DATA C(14) /-0.00000 00000 00270 1D0/
      DATA C(15) / 0.00000 00000 00040 4D0/
      DATA C(16) /-0.00000 00000 00006 1D0/
      DATA C(17) / 0.00000 00000 00000 9D0/
      DATA C(18) /-0.00000 00000 00000 1D0/

      IF(X .EQ. ONE) THEN
       DDILOG=PI6
       RETURN
      ELSE IF(X .EQ. MONE) THEN
       DDILOG=MALF*PI6
       RETURN
      END IF
      T=-X
      IF(T .LE. MTWO) THEN
       Y=MONE/(ONE+T)
       S=ONE
       A=-PI3+HALF*(LOG(-T)**2-LOG(ONE+ONE/T)**2)
      ELSE IF(T .LT. MONE) THEN
       Y=MONE-T
       S=MONE
       A=LOG(-T)
       A=-PI6+A*(A+LOG(ONE+ONE/T))
      ELSE IF(T .LE. MALF) THEN
       Y=(MONE-T)/T
       S=ONE
       A=LOG(-T)
       A=-PI6+A*(MALF*A+LOG(ONE+T))
      ELSE IF(T .LT. ZERO) THEN
       Y=-T/(ONE+T)
       S=MONE
       A=HALF*LOG(ONE+T)**2
      ELSE IF(T .LE. ONE) THEN
       Y=T
       S=ONE
       A=ZERO
      ELSE
       Y=ONE/T
       S=MONE
       A=PI6+HALF*LOG(T)**2
      END IF

      H=Y+Y-ONE
      ALFA=H+H
      B1=ZERO
      B2=ZERO
      DO 1 I = 18,0,-1
      B0=C(I)+ALFA*B1-B2
      B2=B1
    1 B1=B0
      DDILOG=-(S*(B0-H*B2)+A)
      RETURN
      END
